# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   ${PROJECT_NAME}
# FileName:      ${FILE_NAME}
# Author:        shen
# Datetime:     ${DATE} ${TIME}
# Description:
#
# ---------------------------------------------------------------------------
import pytest

from APIAutoTest_shen_2 import log_decorator
from APIAutoTest_shen_2.common.read_excel import ReadExcel

#获取张三的数据
case_datas = ReadExcel("zs").get_data()


class TestBPM:
    #调用装饰器，来获取日志的输出到report目录文件
    @log_decorator
    @pytest.mark.parametrize("url,mime,req,case,expect,sql,sql_type1,update",case_datas)
    #用例函数
    def test_bpm(self,req_fix1,url,mime,req,case,expect,sql,sql_type1,update):
        #调用封装的公共请求方法发送请求
        res = req_fix1.request_all(req_url=url,req_method=req,req_mime=mime,case_data=case,sql_type=sql_type1,sql_data=sql,update_key=update)
        print([url,mime,req,case,sql,sql_type1,update,expect])
        try:
            #将key循环取到期望数据的值
            for key in expect:
                #断言，判断获取到的res中期望数据的key是否等于期望数据中的key
                assert res.json().get(key) == expect[key]

        except AssertionError:
            #如果不等于，就抛出断言类型的错误
            raise AssertionError(f"断言失败，用例数据为：{case}，期望数据为：{expect}, 服务器返回的数据为：{res.text}")

        except Exception as e:
            raise e




